using System;
using System.Data;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    public static class GetAccountDetailNoteAndAccountNameWithSnapshot
    {
        public static void Compute(string accountNumber, int lineNumber)
        {
            using (SqlConnection sc = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                sc.Open();

                using (SqlTransaction st =
                    sc.BeginTransaction(IsolationLevel.Snapshot))
                {
                    try
                    {
                        //  1ڂSELECTB
                        AccountDetailDataAccessObject.GetNoteByAccountNumberAndLineNumber(
                            st, accountNumber, lineNumber);

                        //  Ԃ鏈Ƃ܂B
                        //  20bX[vőp܂B
                        System.Threading.Thread.Sleep(20000);

                        //  X[vĂԂɌύXĂA
                        //  1ڂSELECT𔭍sƂ̌擾ł܂B
                        string s = AccountDataAccessObject.GetNameByAccountNumber(
                            st, accountNumber);

                        Console.Out.WriteLine("Snapshotxœǎ悵{0}łB", s);

                        st.Commit();
                    }
                    catch
                    {
                        st.Rollback();
                        throw;
                    }
                }
            }
        }
    }
}
