using System;
using System.Data.SqlClient;
using System.Transactions;

namespace NihonUnisys.ParadiseTwo
{
    public static class TableAdapterPlusTransactionScopeWithSnapshot
    {
        public static void Compute()
        {
            TransactionOptions to = new TransactionOptions();
            to.IsolationLevel = IsolationLevel.Snapshot;

            using (SimpleBankDataSet ds = new SimpleBankDataSet())
            {
                using (TransactionScope ts = new TransactionScope(TransactionScopeOption.Required, to))
                {
                    //  RlNV1ɂ邽߂ɁARlNVOŐB
                    using (SqlConnection sc = new SqlConnection(Properties.Settings.Default.SimpleBankConnectionString))
                    {
                        //  OɃI[vB
                        sc.Open();

                        using (SimpleBankDataSetTableAdapters.AccountTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountTableAdapter())
                        {
                            //  TableAdapterɃRlNVݒB
                            ta.Connection = sc;
                            
                            ta.Fill(ds.Account);
                        }

                        using (SimpleBankDataSetTableAdapters.AccountDetailTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountDetailTableAdapter())
                        {
                            //  TableAdapterɃRlNVݒB
                            ta.Connection = sc;

                            ta.Fill(ds.AccountDetail);
                        }
                    }
                }
            }
        }
    }
}
