using System;
using System.Data.SqlClient;
using System.Transactions;

namespace NihonUnisys.ParadiseTwo
{
    public static class TableAdapterPlusTransactionScopeWithSnapshotWrong
    {
        public static void Compute()
        {
            TransactionOptions to = new TransactionOptions();
            to.IsolationLevel = IsolationLevel.Snapshot;

            using (SimpleBankDataSet ds = new SimpleBankDataSet())
            {
                using (TransactionScope ts = new TransactionScope(TransactionScopeOption.Required, to))
                {
                    using (SimpleBankDataSetTableAdapters.AccountTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountTableAdapter())
                    {
                        ta.Fill(ds.Account);
                    }

                    using (SimpleBankDataSetTableAdapters.AccountDetailTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountDetailTableAdapter())
                    {
                        ta.Fill(ds.AccountDetail);
                    }

                    //  RlNV2ɂȂATransactionScopeiAOoĂ܂B
                }
            }
        }
    }
}
