using System;
using System.Data;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    public static class UpdateAccountNameByAccountNumberWithReadCommitted
    {
        public static void Compute(string name, string accountNumber)
        {
            using (SqlConnection sc = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                sc.Open();

                using (SqlTransaction st = 
                    sc.BeginTransaction(IsolationLevel.ReadCommitted))
                {
                    try
                    {
                        AccountDataAccessObject.UpdateNameByAccountNumber(st,
                            name, accountNumber);

                        //  Ԃ鏈Ƃ܂B
                        //  10bX[vőp܂B
                        System.Threading.Thread.Sleep(10000);

                        st.Commit();
                    }
                    catch
                    {
                        st.Rollback();
                        throw;
                    }
                }
            }
        }
    }
}
