using System;
using System.Data;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    public static class UpdateAccountNameByPhoneNumberWithSerializableAndUpdLock
    {
        public static void Compute(string name, string phoneNumber)
        {
            using (SqlConnection sc = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                sc.Open();

                using (SqlTransaction st =
                    sc.BeginTransaction(IsolationLevel.Serializable))
                {
                    try
                    {
                        //  with (UpdLock)gData Access Objectgp܂B

                        AccountDataAccessObject.UpdateNameByAccountNumber(st, name,
                            AccountDataAccessObject.GetAccountNumberByPhoneNumberWithUpdLock(
                                st, phoneNumber));

                        st.Commit();
                    }
                    catch
                    {
                        st.Rollback();
                        throw;
                    }
                }
            }
        }
    }
}
